summaryrefslogtreecommitdiffstats
path: root/modules.d/95zfcp
diff options
context:
space:
mode:
Diffstat (limited to 'modules.d/95zfcp')
-rwxr-xr-xmodules.d/95zfcp/module-setup.sh34
-rwxr-xr-xmodules.d/95zfcp/parse-zfcp.sh16
2 files changed, 50 insertions, 0 deletions
diff --git a/modules.d/95zfcp/module-setup.sh b/modules.d/95zfcp/module-setup.sh
new file mode 100755
index 0000000..e1f3aa3
--- /dev/null
+++ b/modules.d/95zfcp/module-setup.sh
@@ -0,0 +1,34 @@
+#!/bin/bash
+
+# called by dracut
+check() {
+ arch=${DRACUT_ARCH:-$(uname -m)}
+ [ "$arch" = "s390" -o "$arch" = "s390x" ] || return 1
+
+ require_binaries zfcp_cio_free grep sed seq || return 1
+
+ return 0
+}
+
+# called by dracut
+depends() {
+ return 0
+}
+
+# called by dracut
+installkernel() {
+ instmods zfcp
+}
+
+# called by dracut
+install() {
+ inst_hook cmdline 30 "$moddir/parse-zfcp.sh"
+ inst_multiple zfcp_cio_free grep sed seq
+
+ inst_script /sbin/zfcpconf.sh
+ inst_rules 56-zfcp.rules
+
+ if [[ $hostonly ]]; then
+ inst_simple -H /etc/zfcp.conf
+ fi
+}
diff --git a/modules.d/95zfcp/parse-zfcp.sh b/modules.d/95zfcp/parse-zfcp.sh
new file mode 100755
index 0000000..495aa67
--- /dev/null
+++ b/modules.d/95zfcp/parse-zfcp.sh
@@ -0,0 +1,16 @@
+#!/bin/sh
+
+getargbool 1 rd.zfcp.conf -d -n rd_NO_ZFCPCONF || rm /etc/zfcp.conf
+
+for zfcp_arg in $(getargs rd.zfcp -d 'rd_ZFCP='); do
+ echo "$zfcp_arg" | grep '^0\.[0-9a-fA-F]\.[0-9a-fA-F]\{4\}\(,0x[0-9a-fA-F]\{16\},0x[0-9a-fA-F]\{16\}\)\?$' > /dev/null
+ test $? -ne 0 && die "For argument 'rd.zfcp=$zfcp_arg'\nSorry, invalid format."
+ (
+ IFS=","
+ # shellcheck disable=SC2086
+ set $zfcp_arg
+ echo "$@" >> /etc/zfcp.conf
+ )
+done
+
+zfcp_cio_free